Adding offset in MergeSimSources breaks symmetry assumed by truth matching
Description

When the offset is applied to the TracklD when using the LArSim module MergeSimSources the offset is applied both to the primary
track Id and the "rolled up" track Id that is the negative of the original track Id (see
https://github.com/LArSoft/larsim/blob/b45eb9ed60d76c792bad45784c457ad048f515fd/larsim/MergeSimSources/MergeSimSources.
cxx#L.228). For example a muon with Id 1 the delta rays will typically be assigned an Id of -1. When an offset of 1000 is applied these
are changed to 1001 and 999 respectively, rather than the 1001 and -1001 one would expect. This breaks a symmetry that is
assumed by many truth matching utilities (e.g.

https://github.com/LArSoft/larsim/blob/68017a1f0e7{41c444973ae340a003dd4 1b77aa3/larsim/Utils/TruthMatchUtils.cc#L.179)
meaning these functions can return Ids that match to non-existent particles.

History

#1 - 02/17/2021 10:25 AM - Lynn Garren

Gianluca, are you able to look at this?

#2 - 02/22/2021 10:34 AM - Kyle Knoepfel
Ed, did you mean to specify LArSoft v06_73_00 in the "Occurs In" field?

#3 - 02/22/2021 10:34 AM - Kyle Knoepfel

- Status changed from New to Feedback

#4 - 02/22/2021 10:49 AM - Edward Tyley

No sorry, this bug occurred during an SBND production using v09_08_00 but | was not able to select this version from the drop-down menu, and in
the process of trying accidentally selected the wrong version.

#5 - 03/01/2021 10:31 AM - Kyle Knoepfel
- Assignee set to Gianluca Petrillo

- Status changed from Feedback to Assigned
